Index: src/java/org/jivesoftware/LoginDialog.java
===================================================================
--- src/java/org/jivesoftware/LoginDialog.java	(revision 10832)
+++ src/java/org/jivesoftware/LoginDialog.java	(working copy)
@@ -24,6 +24,7 @@
 import org.jivesoftware.smack.SASLAuthentication;
 import org.jivesoftware.smack.packet.XMPPError;
 import org.jivesoftware.smack.util.StringUtils;
+import org.jivesoftware.smackx.workgroup.packet.Transcript;
 import org.jivesoftware.spark.SessionManager;
 import org.jivesoftware.spark.SparkManager;
 import org.jivesoftware.spark.Workspace;
@@ -50,6 +51,7 @@
 import javax.security.auth.callback.PasswordCallback;
 import javax.swing.ImageIcon;
 import javax.swing.JCheckBox;
+import javax.swing.JComboBox;
 import javax.swing.JFrame;
 import javax.swing.JLabel;
 import javax.swing.JOptionPane;
@@ -230,6 +232,9 @@
         private JLabel accountNameLabel = new JLabel();
         private JLabel serverNameLabel = new JLabel();
         private JLabel ssoServerLabel = new JLabel();
+//        private JLabel profilesLabel = new JLabel("Profiles");
+        
+//        private JComboBox profilesBox = new JComboBox();
 
 
         LoginPanel() {
@@ -308,6 +313,16 @@
                     new GridBagConstraints(1, 6, 2, 1, 1.0, 0.0,
                             GridBagConstraints.EAST, GridBagConstraints.HORIZONTAL, new Insets(5, 5, 0, 5), 0, 0));
 
+//            add(profilesLabel,
+//               new GridBagConstraints(0, 7, 2, 1, 1.0, 0.0,
+//                       GridBagConstraints.EAST, GridBagConstraints.HORIZONTAL, new Insets(5, 5, 0, 5), 0, 0));
+            
+//            add(profilesBox,
+//               new GridBagConstraints(1, 7, 2, 1, 1.0, 0.0,
+//                       GridBagConstraints.EAST, GridBagConstraints.HORIZONTAL, new Insets(5, 5, 0, 5), 0, 0));
+
+//            profilesBox.addItem(SettingsManager.getSettingsFile().getName());
+            
             // Add button but disable the login button initially
             savePasswordBox.addActionListener(this);
             autoLoginBox.addActionListener(this);
Index: src/java/org/jivesoftware/spark/ChatManager.java
===================================================================
--- src/java/org/jivesoftware/spark/ChatManager.java	(revision 10873)
+++ src/java/org/jivesoftware/spark/ChatManager.java	(working copy)
@@ -209,16 +209,32 @@
      * @return the newly created <code>ChatRoom</code>.
      */
     public ChatRoom createChatRoom(String userJID, String nickname, String title) {
-        ChatRoom chatRoom;
-        try {
-            chatRoom = getChatContainer().getChatRoom(userJID);
-        }
-        catch (ChatRoomNotFoundException e) {
-            chatRoom = new ChatRoomImpl(userJID, nickname, title);
-            getChatContainer().addChatRoom(chatRoom);
-        }
-
-        return chatRoom;
+   	 ChatRoom chatRoom;
+       try 
+       {
+      	  /*if(userJID.contains("/"))
+      	  {
+      		  String[] JID = userJID.split("/");
+      		  userJID = JID[0];
+      	  }*/
+           chatRoom = getChatContainer().getChatRoom(userJID);
+       }
+       catch(Exception e) {
+	        chatRoom = SparkManager.getExternalizedChatRoom(nickname);
+	        if(chatRoom == null)
+	        {
+			     chatRoom = new ChatRoomImpl(userJID, nickname, title);
+			     LocalPreferences pref = SettingsManager.getLocalPreferences();
+			     if(!pref.isTabsExternalizedOn())
+			   	  getChatContainer().addChatRoom(chatRoom);
+			     else
+			     {
+			   	  //new ChatRoomImpl(userJID, title, title)
+			   	  SparkManager.getChatManager().getChatContainer().externalizeTab((ChatRoomImpl)chatRoom, SparkManager.getChatManager().getChatContainer().getX(), SparkManager.getChatManager().getChatContainer().getY(), false);
+			     }
+	        }  
+       }
+       return chatRoom;
     }
 
     /**
@@ -304,7 +320,6 @@
                 }
 
                 ChatContainer chatRooms = chatManager.getChatContainer();
-
                 try {
                     chatRoom = chatRooms.getChatRoom(jid);
                 }
@@ -604,12 +619,15 @@
                         // Notify Decorators
                         notifySparkTabHandlers(chatRoom);
                     }
+                    if(SparkManager.getExternalizedFrame(chatRoom.getRoomTitle()) != null)
+                    {
+                  	  SparkManager.getExternalizedFrame(chatRoom.getRoomTitle()).setIconImage(SparkRes.getImageIcon(SparkRes.SMALL_MESSAGE_EDIT_IMAGE).getImage());
+                    }
                 }
                 catch (ChatRoomNotFoundException e) {
                     // Do nothing
                 }
 
-
                 contactList.setIconFor(from, SparkRes.getImageIcon(SparkRes.SMALL_MESSAGE_EDIT_IMAGE));
             }
         });
@@ -870,7 +888,7 @@
         if (nickname == null) {
             nickname = jid;
         }
-
+ 
         ChatManager chatManager = SparkManager.getChatManager();
         ChatRoom chatRoom = chatManager.createChatRoom(jid, nickname, nickname);
         if (body != null) {
Index: src/java/org/jivesoftware/spark/SparkManager.java
===================================================================
--- src/java/org/jivesoftware/spark/SparkManager.java	(revision 10873)
+++ src/java/org/jivesoftware/spark/SparkManager.java	(working copy)
@@ -17,9 +17,11 @@
 import org.jivesoftware.smack.XMPPConnection;
 import org.jivesoftware.smackx.MessageEventManager;
 import org.jivesoftware.smackx.ServiceDiscoveryManager;
+import org.jivesoftware.spark.component.tabbedPane.SparkTabbedPane;
 import org.jivesoftware.spark.filetransfer.SparkTransferManager;
 import org.jivesoftware.spark.preference.PreferenceManager;
 import org.jivesoftware.spark.search.SearchManager;
+import org.jivesoftware.spark.ui.ChatFrame;
 import org.jivesoftware.spark.ui.ChatPrinter;
 import org.jivesoftware.spark.ui.ChatRoom;
 import org.jivesoftware.spark.ui.ContactList;
@@ -28,6 +30,7 @@
 import org.jivesoftware.sparkimpl.profile.VCardManager;
 
 import java.awt.Component;
+import java.awt.Frame;
 import java.awt.KeyboardFocusManager;
 import java.awt.Toolkit;
 import java.awt.datatransfer.DataFlavor;
@@ -37,8 +40,10 @@
 import java.beans.PropertyChangeListener;
 import java.io.File;
 import java.text.SimpleDateFormat;
+import java.util.ArrayList;
 
 import javax.swing.ImageIcon;
+import javax.swing.JFrame;
 
 /**
  * Used as the System Manager for the Spark IM client. The SparkManager is responsible for
@@ -408,5 +413,57 @@
         }
         return mainImage;
     }
+    
+    
+    /**
+     * Returns ChatRoomImpl of an externalized Tab
+     * @param participantNickname
+     * @return ChatRoomImpl of an externalized Tab
+     */
+    
+    public static ChatRoom getExternalizedChatRoom(String participantNickname)
+    {
+   	 Frame[] frames = JFrame.getFrames();
+   	 		for(Frame frame : frames)
+      	  	{
+       	  		if(frame.getTitle().equals(participantNickname)){
+       	  			if(((JFrame) frame).getContentPane().getComponent(0) instanceof ChatRoom)
+						{
+       	  				return (ChatRoom)(((JFrame) frame).getContentPane().getComponent(0));
+						}
+       	  		}
+       	  	}
+       	  	return null;
+        }
+    
+    /**
+     * Returns frame of an externalized Tab
+     * @param participantNickname
+     * @return frame of an externalized Tab
+     */
+    public static JFrame getExternalizedFrame(String participantNickname)
+    {
+   		Frame[] frames = JFrame.getFrames();
+   	  	for(Frame frame : frames)
+   	  	{
+   	  		if(frame.getTitle().equals(participantNickname) && !(frame instanceof ChatFrame)){
+   	  			return (JFrame)frame;
+   	  		}
+   	  	}
+   	  	return null;
+    }
+    
+    public static ArrayList<ChatRoom> getExternalizedChatRooms()
+    {
+   	  ArrayList<JFrame> frames = SparkTabbedPane.getExternalizedFrames();
+   	  ArrayList<ChatRoom> rooms = new ArrayList<ChatRoom>();
+   	  
+   	  for(Frame frame : frames)
+  	  	  {
+   		  rooms.add((ChatRoom)(((JFrame) frame).getContentPane().getComponent(0)));
+  	  	  }
+   	  
+   	  return rooms;
+    }
 
 }
Index: src/java/org/jivesoftware/spark/component/tabbedPane/SparkTabbedPane.java
===================================================================
--- src/java/org/jivesoftware/spark/component/tabbedPane/SparkTabbedPane.java	(revision 10873)
+++ src/java/org/jivesoftware/spark/component/tabbedPane/SparkTabbedPane.java	(working copy)
@@ -19,13 +19,21 @@
 import java.util.List;
 
 import javax.swing.Icon;
+import javax.swing.ImageIcon;
+import javax.swing.JFrame;
 import javax.swing.JLabel;
 import javax.swing.JPanel;
 import javax.swing.JTabbedPane;
 
 import org.jivesoftware.Spark;
+import org.jivesoftware.resource.Res;
 import org.jivesoftware.resource.SparkRes;
+import org.jivesoftware.spark.SparkManager;
+import org.jivesoftware.spark.ui.ChatRoom;
+import org.jivesoftware.spark.ui.ChatRoomButton;
+import org.jivesoftware.spark.ui.ChatRoomListener;
 import org.jivesoftware.spark.ui.conferences.ConferenceUtils;
+import org.jivesoftware.spark.ui.rooms.ChatRoomImpl;
 import org.jivesoftware.spark.util.ModelUtil;
 import org.jivesoftware.spark.util.SwingWorker;
 import org.jivesoftware.spark.util.log.Log;
@@ -38,23 +46,30 @@
  * @author Derek DeMoro
  */
 public class SparkTabbedPane extends JPanel implements MouseListener {
-    private JPanel tabs;
+	
+	 private JPanel tabs;
     private JPanel mainPanel;
-
+    
     private boolean closeButtonEnabled;
     private Icon closeInactiveButtonIcon;
     private Icon closeActiveButtonIcon;
-
+    
+    ChatRoomButton internalizeButton;
+   
+    
     private boolean popupAllowed;
 
     private boolean activeButtonBold;
-
-
+    
     private int tabPlacement = JTabbedPane.TOP;
 
     private Color backgroundColor;
     private Color borderColor;
-
+    
+    private static ArrayList<JFrame> externalizedFrames = new ArrayList<JFrame>();
+    public static boolean externalizeTheTab = false;
+    private static Dimension coordinates = new Dimension(100, 100);
+    
     /**
      * The default Hand cursor.
      */
@@ -76,7 +91,6 @@
 
     public SparkTabbedPane(int placement) {
         this.tabPlacement = placement;
-
         createUI();
     }
 
@@ -418,7 +432,11 @@
         deselectAllTabsExcept(tab);
 
         tab.setSelected(true);
-        fireTabSelected(tab, getSelectedComponent(), getIndex(tab));
+        
+        if(!externalizeTheTab)
+        {
+      	  fireTabSelected(tab, getSelectedComponent(), getIndex(tab));
+        }
     }
 
     public void mousePressed(MouseEvent e) {
@@ -434,6 +452,14 @@
     }
 
     public void mouseReleased(MouseEvent e) {
+   	 if(e.getY() < -5 || e.getY() > 30)
+   	 {
+   		 externalizeTab((ChatRoomImpl)this.getComponentAt((getSelectedIndex())), e.getXOnScreen(), e.getYOnScreen(), true);
+   	 }
+   	 else
+   	 {
+   		
+		 }
     }
 
     public void mouseEntered(MouseEvent e) {
@@ -602,4 +628,79 @@
     public void setBorderColor(Color borderColor) {
         this.borderColor = borderColor;
     }
+    
+    public void externalizeTab(ChatRoomImpl chatroom, int x, int y, boolean externalizedATab)
+	 {
+   	 
+		 final JFrame externalFrame = new JFrame();
+		 externalFrame.setTitle(chatroom.getParticipantNickname());
+		 
+		 Dimension d;
+		 if(SparkManager.getChatManager().getChatContainer().getWidth() == 0)
+			 d = new Dimension(600, 400);
+		 else
+			 d = SparkManager.getChatManager().getChatContainer().getSize();
+		 
+		 if(externalizedATab)
+   	 {
+	   	 externalizeTheTab = true;
+	   	 this.removeTabAt(getSelectedIndex());
+			 SparkManager.getChatManager().getChatContainer().closeTab(this);
+			 externalizeTheTab = false;
+			 externalFrame.setBounds(x - (d.width/2), y, d.width, d.height);
+   	 }
+   	 else
+   	 {
+   		 externalFrame.setBounds(coordinates.width, coordinates.height, d.width, d.height);
+   		 coordinates.setSize(coordinates.width + 25, coordinates.height + 25);
+   		 if(coordinates.width == 400)
+   		 {
+   			 coordinates.setSize(100, 100);
+   		 }
+   	 }
+		 
+		 externalFrame.addWindowListener(new java.awt.event.WindowAdapter(){
+			public void windowClosing(java.awt.event.WindowEvent evt)
+			{
+				ChatRoom chatRoom = (ChatRoom)(externalFrame.getContentPane().getComponent(0));
+				SparkManager.getWorkspace().getTranscriptPlugin().chatRoomClosed((ChatRoom)(externalFrame.getContentPane().getComponent(0)));
+				externalFrame.setTitle("");
+				externalFrame.dispose();
+				getExternalizedFrames().remove(externalFrame);
+				chatRoom.closeChatRoom();
+			}
+		 });
+		 String[] jid = chatroom.getParticipantJID().split("/spark");
+		 
+		 chatroom.closeChatRoom();
+		 ChatRoomImpl externalChatroom = new ChatRoomImpl(jid[0], chatroom.getParticipantNickname(), chatroom.getTabTitle());
+		
+		 try
+		 {
+			 externalFrame.setIconImage(((ImageIcon)(SparkManager.getContactList().getContactItemByJID(chatroom.getParticipantJID())).getIcon()).getImage());
+		 }
+		 catch(Exception e)
+		 {
+			 externalFrame.setIconImage(SparkRes.getImageIcon("CLEAR_BALL_ICON").getImage());
+		 }
+		 
+		 internalizeButton = new ChatRoomButton("", SparkRes.getImageIcon("RIGHT_ARROW_IMAGE"));
+	    internalizeButton.setToolTipText(Res.getString("message.internalize.tab"));
+		 externalChatroom.setInternalizeButton(internalizeButton);
+		 externalChatroom.getToolBar().addChatRoomButton(internalizeButton);
+	    for (ChatRoomListener chatRoomListener : new ArrayList<ChatRoomListener>(SparkManager.getChatManager().getChatContainer().getChatRoomListener())) 
+	    {
+          chatRoomListener.chatRoomOpened(externalChatroom);
+	    }
+	    externalFrame.add(externalChatroom);
+	    externalFrame.setVisible(true);
+	    externalizedFrames.add(externalFrame);
+	    externalChatroom.getChatInputEditor().requestFocus();
+	    externalChatroom.getChatInputEditor().requestFocusInWindow();
+	 }
+    
+    public static ArrayList<JFrame> getExternalizedFrames()
+    {
+   	 return externalizedFrames;
+    }
 }
Index: src/java/org/jivesoftware/spark/filetransfer/SparkTransferManager.java
===================================================================
--- src/java/org/jivesoftware/spark/filetransfer/SparkTransferManager.java	(revision 10873)
+++ src/java/org/jivesoftware/spark/filetransfer/SparkTransferManager.java	(working copy)
@@ -335,20 +335,20 @@
     public void sendScreenshot(final ChatRoomButton button, final ChatRoom room) {
         button.setEnabled(false);
 
-        final MainWindow mainWindow = SparkManager.getMainWindow();
-        final ChatFrame chatFrame = SparkManager.getChatManager().getChatContainer().getChatFrame();
-
-        final boolean mainWindowVisible = mainWindow.isVisible();
-        final boolean chatFrameVisible = chatFrame.isVisible();
-
-        if (mainWindowVisible) {
-            mainWindow.setVisible(false);
-        }
-
-        if (chatFrameVisible) {
-            chatFrame.setVisible(false);
+        final Frame[] frames = JFrame.getFrames();
+        final Frame[] framesToSetVisible = new Frame[JFrame.getFrames().length];
+        
+        int i = 0;
+        for(Frame frame : frames)
+        {
+      	  if(frame.isVisible())
+      	  { 
+      		  framesToSetVisible[i] = frame;
+      		  i++;
+      		  frame.setVisible(false);  
+      	  }
         }
-
+        
         final SwingWorker worker = new SwingWorker() {
             public Object construct() {
                 try {
@@ -358,15 +358,11 @@
                 }
                 catch (Throwable e) {
                     Log.error(e);
-
-                    if (mainWindowVisible) {
-                        mainWindow.setVisible(true);
+                    
+                    for(Frame frame : framesToSetVisible)
+                    {
+                  	  frame.setVisible(true);
                     }
-
-                    if (chatFrameVisible) {
-                        chatFrame.setVisible(true);
-                    }
-
                 }
                 return null;
             }
@@ -403,14 +399,11 @@
                         frame.dispose();
                         frame.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
 
-                        if (mainWindowVisible) {
-                            mainWindow.setVisible(true);
-                        }
-
-                        if (chatFrameVisible) {
-                            chatFrame.setVisible(true);
+                        for(Frame frame : framesToSetVisible)
+                        {
+                      	  frame.setVisible(true);
                         }
-
+                        
                         selectionPanel.removeMouseListener(this);
                     }
                 });
@@ -420,12 +413,10 @@
                         if (e.getKeyChar() == KeyEvent.VK_ESCAPE) {
                             frame.dispose();
                             frame.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
-                            if (mainWindowVisible) {
-                                mainWindow.setVisible(true);
-                            }
-
-                            if (chatFrameVisible) {
-                                chatFrame.setVisible(true);
+                            
+                            for(Frame frame : framesToSetVisible)
+                            {
+                          	  frame.setVisible(true);
                             }
                         }
                     }
@@ -540,7 +531,6 @@
 
         // The image must first be wrapped in a style
         Style style = doc.addStyle("StyleName", null);
-
         SendMessage sendingUI = new SendMessage();
         try {
             transfer.sendFile(file, "Sending file");
@@ -592,6 +582,9 @@
             Log.error(e);
         }
 
+        JFrame frame = SparkManager.getExternalizedFrame(contactItem.getDisplayName());
+        frame.toFront();
+        frame.requestFocus();
         chatRoom.scrollToBottom();
         return chatRoom;
     }
Index: src/java/org/jivesoftware/spark/ui/ChatArea.java
===================================================================
--- src/java/org/jivesoftware/spark/ui/ChatArea.java	(revision 10873)
+++ src/java/org/jivesoftware/spark/ui/ChatArea.java	(working copy)
@@ -17,6 +17,7 @@
 import org.jivesoftware.spark.util.BrowserLauncher;
 import org.jivesoftware.spark.util.ModelUtil;
 import org.jivesoftware.spark.util.log.Log;
+import org.jivesoftware.sparkimpl.plugin.emoticons.Emoticon;
 import org.jivesoftware.sparkimpl.plugin.emoticons.EmoticonManager;
 import org.jivesoftware.sparkimpl.settings.local.LocalPreferences;
 import org.jivesoftware.sparkimpl.settings.local.SettingsManager;
@@ -24,6 +25,7 @@
 import javax.swing.AbstractAction;
 import javax.swing.Icon;
 import javax.swing.JComponent;
+import javax.swing.JFrame;
 import javax.swing.JMenuItem;
 import javax.swing.JPopupMenu;
 import javax.swing.JTextPane;
@@ -207,8 +209,7 @@
         boolean bold = false;
         boolean italic = false;
         boolean underlined = false;
-
-
+        
         final StringTokenizer tokenizer = new StringTokenizer(text, " \n \t,", true);
         while (tokenizer.hasMoreTokens()) {
             String textFound = tokenizer.nextToken();
@@ -219,12 +220,12 @@
             }
             else if ( textFound.startsWith("\\\\") || (textFound.indexOf("://") > 0 && textFound.indexOf(".") < 1) ) {
                 insertAddress(textFound);
-            }     
+            }   
             else if (!insertImage(textFound)) {
                 insertText(textFound);
-            }
+            }    
         }
-
+        
         // By default, always have decorations off.
         StyleConstants.setBold(styles, bold);
         StyleConstants.setItalic(styles, italic);
@@ -303,21 +304,26 @@
      * @return true if the image was found, otherwise false.
      */
     public boolean insertImage(String imageKey) {
-        if(!forceEmoticons && !SettingsManager.getLocalPreferences().areEmoticonsEnabled()){
-            return false;
-        }
-        final Document doc = getDocument();
-        Icon emotion = emoticonManager.getEmoticonImage(imageKey.toLowerCase());
-        if (emotion == null) {
-            return false;
-        }
-
-        setEditable(true);
-        select(doc.getLength(), doc.getLength());
-        insertIcon(emotion);
-        setEditable(false);
-
-        return true;
+   	  if(!imageKey.equals(" ") && Emoticon.getAllEquivalants().contains(imageKey))
+   	  {
+	        if(!forceEmoticons && !SettingsManager.getLocalPreferences().areEmoticonsEnabled()){
+	            return false;
+	        }
+	        final Document doc = getDocument();
+	        Icon emotion = emoticonManager.getEmoticonImage(imageKey.toLowerCase());
+	        if (emotion == null) {
+	            return false;
+	        }
+	      
+	        //setEditable(true);
+	        select(doc.getLength(), doc.getLength());
+	        insertIcon(emotion);
+	        //setEditable(false);
+	        
+	        return true;
+   	  }
+   	  else
+   		  return false;
     }
 
     /**
